ListMultimap
Date: 2016-05-24

com.google.common.collect

## Interface ListMultimap<K,V>

- All Superinterfaces:
    Multimap<K,V>
  All Known Implementing Classes:
    ArrayListMultimap, ForwardingListMultimap, ImmutableListMultimap, LinkedListMultimap

      @GwtCompatible
      public interface ListMultimap<K,V>
      extends Multimap<K,V>

  A `Multimap` that can hold duplicate key-value pairs and that maintains the insertion ordering of values for a given key. See the `Multimap` documentation for information common to all multimaps.

  The `get(K)`, `removeAll(java.lang.Object)`, and `replaceValues(K, java.lang.Iterable<? extends V>)` methods each return a `List` of values. Though the method signature doesn't say so explicitly, the map returned by `asMap()` has `List` values.

  See the Guava User Guide article on `Multimap`.

  Since:
    2.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Map<K,java.util.Collection<V>>` | `asMap()` Returns a view of this multimap as a `Map` from each distinct key to the nonempty collection of that key's associated values.
    `boolean` | `equals(java.lang.Object obj)` Compares the specified object to this multimap for equality.
    `java.util.List<V>` | `get(K key)` Returns a view collection of the values associated with `key` in this multimap, if any.
    `java.util.List<V>` | `removeAll(java.lang.Object key)` Removes all values associated with the key `key`.
    `java.util.List<V>` | `replaceValues(K key, java.lang.Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.

    - ### Methods inherited from interface com.google.common.collect.Multimap

      `clear, containsEntry, containsKey, containsValue, entries, hashCode, isEmpty, keys, keySet, put, putAll, putAll, remove, size, values`

- - ### Method Detail

    - #### get

          java.util.List<V> get(@Nullable
                              K key)

      Returns a view collection of the values associated with `key` in this multimap, if any. Note that when `containsKey(key)` is false, this returns an empty collection, not `null`.

      Changes to the returned collection will update the underlying multimap, and vice versa.

      Because the values for a given key may have duplicates and follow the insertion ordering, this method returns a `List`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `get` in interface `Multimap<K,V>`

    - #### removeAll

          java.util.List<V> removeAll(@Nullable
                                    java.lang.Object key)

      Removes all values associated with the key `key`.

      Once this method returns, `key` will not be mapped to any values, so it will not appear in `Multimap.keySet()`, `Multimap.asMap()`, or any other views.

      Because the values for a given key may have duplicates and follow the insertion ordering, this method returns a `List`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `removeAll` in interface `Multimap<K,V>`
      Returns:
        the values that were removed (possibly empty). The returned collection may be modifiable, but updating it will have no effect on the multimap.

    - #### replaceValues

          java.util.List<V> replaceValues(K key,
                                        java.lang.Iterable<? extends V> values)

      Stores a collection of values with the same key, replacing any existing values for that key.

      If `values` is empty, this is equivalent to `removeAll(key)`.

      Because the values for a given key may have duplicates and follow the insertion ordering, this method returns a `List`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `replaceValues` in interface `Multimap<K,V>`
      Returns:
        the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

    - #### asMap

          java.util.Map<K,java.util.Collection<V>> asMap()

      Returns a view of this multimap as a `Map` from each distinct key to the nonempty collection of that key's associated values. Note that `this.asMap().get(k)` is equivalent to `this.get(k)` only when `k` is a key contained in the multimap; otherwise it returns `null` as opposed to an empty collection.

      Changes to the returned map or the collections that serve as its values will update the underlying multimap, and vice versa. The map does not support `put` or `putAll`, nor do its entries support `setValue`.

      Note: The returned map's values are guaranteed to be of type `List`. To obtain this map with the more specific generic type `Map<K, List<V>>`, call `Multimaps.asMap(ListMultimap)` instead.

      Specified by:
        `asMap` in interface `Multimap<K,V>`

    - #### equals

          boolean equals(@Nullable
                       java.lang.Object obj)

      Compares the specified object to this multimap for equality.

      Two `ListMultimap` instances are equal if, for each key, they contain the same values in the same order. If the value orderings disagree, the multimaps will not be considered equal.

      An empty `ListMultimap` is equal to any other empty `Multimap`, including an empty `SetMultimap`.

      Specified by:
        `equals` in interface `Multimap<K,V>`
      Overrides:
        `equals` in class `java.lang.Object`